
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>In-depth Profiling of JSBridge / iVAN</title>

    <meta name="description" content="In-depth Profiling of JSBridge Overview Developers who have been involved in hybrid development are familiar with frameworks such as Ionic and PhoneGap. These frameworks cover a web-based app in a Native layer and then call the local library through the JSBridge technology. Before">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">In-depth Profiling of JSBridge</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><a href="https://yqfile.alicdn.com/03038d3e26f2cf384a4430ec7c45d09dfbddbb5e.jpeg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzAzMDM4ZDNlMjZmMmNmMzg0YTQ0MzBlYzdjNDVkMDlkZmJkZGJiNWUuanBlZw==.jpg"></a></p>
<h2>Overview</h2>
<p>Developers who have been involved in hybrid development are familiar with frameworks such as Ionic and PhoneGap. These frameworks cover a web-based app in a Native layer and then call the local library through the JSBridge technology.</p>
<p>Before diving into the details of JSBridge technology, let us briefly explore the traditional implementation process.</p>
<h2>Android Environment</h2>
<h3>Calling JS in Native</h3>
<p>Calling JS in Native is relatively simple: you just need to observe the rule of "<code>javascript: method name ('parameter, needed to be converted to string')</code>".</p>
<p><b>Call method before Android 4.4:</b></p>
<pre><code>// mWebView = new WebView(this);
mWebView.loadUrl("javascript: method name ('parameter, needed to be converted to string')"); 

//Run in UI thread
 runOnUiThread(new Runnable() {
        @Override
        public void run() {
            mWebView.loadUrl("javascript: method name ('parameter, needed to be converted to string')");
            Toast.makeText(Activity name.this, "call method...", Toast.LENGTH_SHORT).show();
        }
});
</code></pre>
<p><b>Call method for Android 4.4 and newer:</b></p>
<pre><code>mWebView.evaluateJavascript("javascript: method name ('parameter, needed to be converted to string')", new ValueCallback() {
        @Override
        public void onReceiveValue(String value) {
            //Here the value refers to the returned value of the corresponding JS method
        }
});
</code></pre>
<p>Description:</p>
<ul>
<li>Before Android 4.4, Native calls JS method through loadUrl. In this approach, only a JS method is executed, but the returned value of this method cannot be obtained.</li>
<li>For Android 4.4 and newer versions, the JS methods are called asynchronously through evaluateJavascript and the returned value is available in onReceiveValue.</li>
<li>This method is not suitable for transmission of large amounts of data (the interface approach is recommended for a large amount of data).</li>
<li>mWebView.loadUrl("javascript: The mWebView.loadUrl ("javascript:method name ('parameter, needed to be converted to string'")") function needs to be run in the UI thread because mWebView is a UI control.</li>
</ul>
<h3>Calling Native in JS</h3>
<p>The call of Native in JS requires the @JavascriptInterface annotation to the WebView. There is a loophole, which will be explained later. To make JS native, you need to set the following attributes for WebView:</p>
<pre><code>WebSettings webSettings = mWebView.getSettings();
 //Android container allows JS scripts
webSettings.setJavaScriptEnabled(true);
//Android container sets the bridge object
mWebView.addJavascriptInterface(getJSBridge(), "JSBridge");
</code></pre>
<p>Here we see <code>getJSBridge()</code>. In Native, <code>addJavascriptInterface</code> is used to add an exposed JS bridge object, and then the corresponding API method is declared inside the object.</p>
<pre><code>private Object getJSBridge(){
    Object insertObj = new Object(){
        @JavascriptInterface
        public String foo(){
            return "foo";
        }  

        @JavascriptInterface
        public String foo2(final String param){
            return "foo2:" + param;
        }  

    };
    return insertObj;
}
</code></pre>
<p>Calling the Native method in HTML.</p>
<pre><code>//Call method 1
window.JSBridge.foo(); //Returned: 'foo'
//Call method 2
window.JSBridge.foo2('test');//Returned: 'foo2:test'
</code></pre>
<p>Description:</p>
<ul>
<li>In Android 4.2 (API17) and newer versions, the exposed API should carry an <code>@JavascriptInterface</code> annotation. Otherwise, the method will not be found.</li>
<li>Before API17, <code>addJavascriptInterface</code> has a potential security risk. Hackers can get the Native-registered JS object by decompiling and obtaining sensitive information, and then launching attacks by reflecting Java's built-in static classes on the page.</li>
<li>JS calls Native-exposed API and gets the corresponding returned value.</li>
</ul>
<h2>iOS Environment</h2>
<h3>Calling JS in Native</h3>
<p>The method to call JS in Native is relatively simple. Native calls the function that HTML binds to the window through stringByEvaluatingJavaScriptFromString. Note the OC and Swift writing styles.</p>
<pre><code>//Swift
webview.stringByEvaluatingJavaScriptFromString("method name (parameter)")
//OC
[webView stringByEvaluatingJavaScriptFromString:@"method name (parameter);"];
</code></pre>
<p>Description:</p>
<ul>
<li>When you call JS methods in Native, you can get the returned value of the JS method.</li>
<li>This method is not suitable for transmission of large amounts of data (the interface approach is recommended for a large amount of data).</li>
</ul>
<h3>Calling Native in JS</h3>
<p>In Native, the API can be bound to JSContext through the introduction of the official JavaScriptCore library (iOS7 and above) (and then JS can be called in HTML through window.top. <em>*</em>).</p>
<p>Introduce the official library file</p>
<pre><code>#import &lt;JavaScriptCore/JavaScriptCore.h&gt;
</code></pre>
<p>Native registers the API function (OC)</p>
<pre><code>-(void)webViewDidFinishLoad:(UIWebView *)webView{
    [self hideProgress];
    [self setJSInterface];
}

-(void)setJSInterface{

    JSContext *context =[_wv valueForKeyPath:@"documentView.webView.mainFrame.javaScriptContext"];

    // API method registered with a name of "foo"
    context[@"foo"] = ^() {

        //Get the parameter
        NSArray *args = [JSContext currentArguments];
        NSString *title = [NSString stringWithFormat:@"%@",[args objectAtIndex:0]];
        //Do some logic of your own
        //A value is returned: 'foo:'+title
        return [NSString stringWithFormat:@"foo:%@", title];
    };
}
</code></pre>
<p>Calling Native methods in JS in HTML</p>
<pre><code>window.top.foo('test');
</code></pre>
<p>Description:</p>
<ul>
<li>This approach was not available until iOS 7. Prior to iOS7, JS could not call Native directly. JS can call Native indirectly only through JSBridge.</li>
<li>JS can call the exposed API and get the corresponding returned value.</li>
<li>Native iOS cannot be called by JS, but APIs can be made open to JS calls by introducing the official third-party "JavaScriptCore".</li>
</ul>
<h2>What is JSBridge?</h2>
<p>As its name implies, JSBridge serves as a bridge between JS and Native. In fact, JSBridge, also known as the Hybrid app technology, is a communication method between JS and Native. In JSBridge, Native calls JS only through a fixed bridge object, and vice versa.</p>
<p><a href="https://yqfile.alicdn.com/db7cf12440d2e3aef7005f0f8577acd2b55655cd.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2RiN2NmMTI0NDBkMmUzYWVmNzAwNWYwZjg1NzdhY2QyYjU1NjU1Y2QucG5n.jpg"></a></p>
<h3>JSBridge Implementation Process</h3>
<p>The process of JSBridge implementation can be summarized as follows. An H5 page triggers a URL in some way and Native captures the URL for analysis. Native then performs the processing and calls the H5 JSBridge object for transfer and callback.</p>
<p>Since the native WebView/UIWebView controls have already achieved data communication with JS, why do we still need JSBridge?</p>
<p>The following list describes the motivations for using JSBridge:</p>
<ul>
<li>The addJavascriptInterface method has security loopholes in the versions lower than Android 4.2.</li>
<li>JS is unable to call Native in versions lower than iOS 7.</li>
<li>The URL scheme interaction is a set of existing mature solutions that are perfectly compatible with various versions and with the technology of older versions.</li>
</ul>
<h3>URL Scheme</h3>
<p>URL scheme is a link, like the URL, designed to facilitate direct mutual calls between apps. You can open the system application for a system URL scheme. Otherwise, you can try to find whether an app has registered such a scheme and open that corresponding app. <br />
Note: A scheme will be valid only after native app registration is completed.</p>
<p>However, in an actual development scenario, the app does not register the corresponding scheme. Instead, the front-end page triggers the scheme (such as iframe.src) in some way. Native captures the corresponding URL to trigger the event and gets the current triggering URL, and then Native checks if the method is triggered according to the defined protocol.</p>
<h2>JSBridge: Technical Implementation</h2>
<p>To implement JSBridge, we need to analyze the following steps:</p>
<ul>
<li>Step 1: Design a global bridge object for Native to interact with JS</li>
<li>Step 2: How JS calls Native</li>
<li>Step 3: How Native knows that the API is called</li>
<li>Step 4: URL-parameter and callback format</li>
<li>Step 5: How Native calls JS</li>
<li>Step 6: Registration and format of the API method in H5</li>
</ul>
<p>The figure below shows the complete process of JSBridge:</p>
<p><a href="https://yqfile.alicdn.com/52230fabe544285b66e12c858ce2981c008c7880.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzUyMjMwZmFiZTU0NDI4NWI2NmUxMmM4NThjZTI5ODFjMDA4Yzc4ODAucG5n.jpg"></a></p>
<h3>Designing Global Bridge Objects for Interaction Between Native and JS</h3>
<p>We stipulate that the communication between JS and Native must be implemented through an H5 global object – JSBridge. The object has the following characteristics:</p>
<p>The object name is "JSBridge", which is an attribute of the global object window in the H5 page. It is elaborated as:</p>
<pre><code>var JSBridge = window.JSBridge || (window.JSBridge = {});
</code></pre>
<p>This object has the following methods:</p>
<ul>
<li>registerHandler (String, Function) H5 call. It registers the local JS method, after which Native can make the call through JSBridge. After the call, the method is registered in the local variable messageHandlers.</li>
<li>callHandler (String, JSON, Function) H5 call. It calls the Native open API, after which the URL scheme is triggered locally. During the call, the callback ID is stored in the local variable responseCallbacks.</li>
<li>_handleMessageFromNative (JSON) Native call. Native calls the method registered on the H5 page, or notifies the H5 page of the execution of the callback method.</li>
</ul>
<p><a href="https://yqfile.alicdn.com/edb4486123ea9092db6fdbe2d28b682c9b9451cb.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2VkYjQ0ODYxMjNlYTkwOTJkYjZmZGJlMmQyOGI2ODJjOWI5NDUxY2IucG5n.jpg"></a></p>
<h3>Calling Native in JS</h3>
<p>After we define the global bridge object, we can use its callHandler method to call the Native API.</p>
<p><b>Internal implementation process of the callHandler function</b></p>
<p>The callHandler execution includes the following internal steps:<br />
1.Determine whether a callback function exists. If yes, a callback function ID is generated, and the ID and the corresponding callback is added to the callback function set responseCallbacks.<br />
2.The input data and method name are spliced into a URL scheme through a specific parameter conversion method.</p>
<pre><code>//The URL scheme format
//Basically the useful information is the callbackId, handlerName and data at the end
//Native will analyze the scheme after it captures it
var uri = CUSTOM_PROTOCOL_SCHEME://API_Name:callbackId/handlerName?data
</code></pre>
<p>3.A internal hidden which has long been ready iframe is used for triggering the scheme</p>
<pre><code>//Process of creating the hidden iframe
var messagingIframe = document.createElement('iframe');
messagingIframe.style.display = 'none';
document.documentElement.appendChild(messagingIframe);
//Trigger the scheme
messagingIframe.src = uri;
</code></pre>
<p>Note: Normally it is possible to initiate a network request through window.location.href. However, there is a very serious problem when we change the value of window.location.href several times in succession: the Native layer can only receive the last request, while ignoring all the previous ones. To avoid this problem, we need iframe to initiate network requests at the JS end.</p>
<h3>Native Notifying the API to be Called</h3>
<p>In our previous step, we successfully triggered the scheme on the H5 page. <br />
Our next step is to explore how Native captures the scheme triggering event.<br />
Android and iOS have their respective handling approaches.</p>
<h4>Android</h4>
<p>In Android (in WebViewClient), the <code>shouldoverrideurlloading</code> helps to capture the URL scheme triggering event.</p>
<pre><code>public boolean shouldOverrideUrlLoading(WebView view, String url){
    //If false is returned, WebView handles the link URL. If true is returned, WebView executes the URL following the procedures
    return true;
}
</code></pre>
<h4>iOS</h4>
<p>iOS, UIWebView has a unique feature: all the network requests initiated in the UIWebView can be notified to the Native layer through the delegate function. In this way, we can capture the URL scheme triggering event in WebView (the principle is to use <code>shouldStartLoadWithRequest</code>).</p>
<pre><code>- (BOOL)webView:(UIWebView <em>)webView shouldStartLoadWithRequest:(NSURLRequest </em>)request navigationType:(UIWebViewNavigationType)navigationType {
    NSURL *url = [request URL];

    NSString *requestString = [[request URL] absoluteString];
    //Get the URL scheme for self-processing
</code></pre>
<h3>Analyzing URL-parameter and Callback Format</h3>
<p>In previous steps, Native has received a JS call method. In the next step, Native should parse the data according to the defined data formats. Native can extract the callback parameter ID, API name, and parameters following this format after receiving the URL, and then follow the steps below.<br />
1. Search for the corresponding API method locally according to API name, and record the callback function ID after the method is executed.<br />
2. Convert the extracted parameters according to the defined parameters.<br />
3. Native executes the corresponding API function method locally.<br />
4. After function execution, find the corresponding callback function ID of this API call, and then assemble the information with the parameter information to be passed into a JSON format parameter.<br />
5. Notify the H5 page for callback via JSBridge.</p>
<h3>Calling JS in Native</h3>
<p>In this step, Native calls H5 JS methods through JSBridge or notify H5 for callback. The messageJSON data format in it has two different types.</p>
<pre><code>JSBridge._handleMessageFromNative(messageJSON);
</code></pre>
<p><b>Native notifies H5 page for callback:  </b><br />
As per the data format, Native notifies H5 about the callback JSON format.</p>
<p><b>Native takes the initiative to call the H5 method: </b><br />
When Native takes the initiative to call H5 methods, the data format is: {handlerName: the API name, data: data, callbackId: the callback ID}:</p>
<ul>
<li>handlerName String type: the open API name to be called in H5</li>
<li>data JSON type: the data to be passed. Its format is fixed to be JSON (because we fix the format of the first parameter received by methods registered in H5 to JSON, and the second to a callback function)</li>
<li>callbackId String type: the callback function ID generated by Native. After H5 execution, the URL scheme is used to notify Native about the successful execution of the API and to pass the parameter.</li>
</ul>
<h3>Registration and Format of the API Method in H5</h3>
<p>Previously we mentioned that Native takes the initiative to call the API methods registered in H5. <br />
Let us now study, how we can register API methods in H5 for the Native to call.</p>
<pre><code>JSBridge.registerHandler('testH5Func',function(data,callback){
    alert('Test data received by the function:'+JSON.stringify(data));
    callback&amp;&amp;callback('Test the postback data...');
});
</code></pre>
<p>As indicated in the code above, the first data is the data passed by the Native. The second callback is encapsulated once internally. After the callback is executed, it triggers the URL scheme and notifies the Native to get the callback information.</p>
<h2>Improving the JSBridge Scheme</h2>
<p>The diagram below shows a JSBridge object.</p>
<p><a href="https://yqfile.alicdn.com/db68a2b9154d16b09ce8046f369ae34199cf2f01.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2RiNjhhMmI5MTU0ZDE2YjA5Y2U4MDQ2ZjM2OWFlMzQxOTljZjJmMDEucG5n.jpg"></a></p>
<p>The following diagram illustrates the full process of JSBridge implementation.</p>
<p><a href="https://yqfile.alicdn.com/1dda1826cc58c69285e46c138ea54245cfe3b66c.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzFkZGExODI2Y2M1OGM2OTI4NWU0NmMxMzhlYTU0MjQ1Y2ZlM2I2NmMucG5n.jpg"></a></p>
<h2>JSBridge in iOS and Android</h2>
<p>In an actual development, how can we develop a unified scheme for different situations in both Android and iOS?</p>
<p><a href="https://yqfile.alicdn.com/b195f63fc710ae75a4266cdc5bce3b5444ce4058.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2IxOTVmNjNmYzcxMGFlNzVhNDI2NmNkYzViY2UzYjU0NDRjZTQwNTgucG5n.jpg"></a></p>
<p>The JSBridge mentioned above is based on the URL scheme. However, if you do not plan to support versions lower than Android 4.2 and iOS 7, you must consider another scheme.</p>
<ul>
<li>Native calls of JS methods remain unchanged</li>
<li>JS calls of Native are no longer through triggering the URL scheme, but through the built-in interaction. Specifically, in Android, Native opens a unified API for JS to call through addJavascriptInterface. Then the URL scheme triggering step is changed to call of the API while the other steps remain the same.</li>
</ul>
<p>In iOS, Native registers a unified API through methods in JavaScriptCore, and the other steps are the same with those in Android.</p>
<h2>Conclusion</h2>
<p>Javascript Bridge is a unified messaging system that enables easy building of cross-language services that allow you to share data and real-time updates among your servers and clients. This article explores in detail the profiling of JSBridge and its implementation process in both iOS and Android respectively.</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 08:58:20</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/url/" title="url">url</a>, <a href="https://www.iamivan.net/tag/javascript/" title="javascript">javascript</a>, <a href="https://www.iamivan.net/tag/cloud/" title="Cloud">Cloud</a>, <a href="https://www.iamivan.net/tag/callback/" title="callback">callback</a>, <a href="https://www.iamivan.net/tag/scheme/" title="scheme">scheme</a>, <a href="https://www.iamivan.net/tag/developer_blog/" title="Developer&lowbar;blog">Developer&lowbar;blog</a>, <a href="https://www.iamivan.net/tag/jsbridge/" title="JSBridge">JSBridge</a>, <a href="https://www.iamivan.net/tag/call_method/" title="Call&lowbar;method">Call&lowbar;method</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>In-depth Profiling of JSBridge的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lp54dRM.html" rel="bookmark">Flash AS学习：讲解Movie Clip Depth&lpar;深度&rpar;的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题 大家对duplicateMovieClip()应该不会陌生吧,它用来复制MC.duplicateMovieClip()有个参数----Depth,它就是用来控制新复制出来的MC的深度,数字越大,代表越顶层.   举个例子:      舞台上有1个MC1,在帧上写           mc1.duplicateMovieClip(&quot;mc2&quot;,2);           mc1.duplicateMovieClip(&quot;mc3&quot;,20);           再加上			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo6O0Dz.html" rel="bookmark">常用Java Profiling工具的分析与比较</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在 Java 程序的开发过程中,不可避免地会遇到内存使用.性能瓶颈等问题.Java Profiler 工具能帮助开发人员快速.有效地定位这些问题,因此成为了 Java 开发过程中的一个重要工具.目前市场上的 Java Profiler 工具种类繁多,本文将对目前比较常见的几种工具进行简要介绍,并从功能.性能等角度作比较,从而帮助 Java 程序员选择合适的 Java Profiler 工具. 本文主要分为三个部分:第一部分简要介绍 Java Profiler 工具的原理:第二部分对目前常见的 J			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze60a9b.html" rel="bookmark">云上Java System Profiling与Debugging&mdash;&mdash;蚂蚁金服观察与实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				从1995年Java1.0beta发布到现在,整整过去了20年.Java的发明源于嵌入式领域,不过后来Java的发展,出乎意料地在企业级应用领域占据了几乎统治的地位.阿里巴巴以及支付宝(就是后来的蚂蚁金服),绝大部分的业务代码都是Java编写的.在Java20岁生日这年,我们用这篇文章记录蚂蚁金服内部,在金融云环境下Java系统的Profiling和Debugging经验与实践,与大家分享交流,有非常特别的意义.希望读者能够从中借鉴到一些解决问题的思路. 线上Profiling/Debuggin			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRq86eb.html" rel="bookmark">PostgreSQL 源码性能诊断&lpar;perf profiling&rpar;指南</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				标签 PostgreSQL , Linux , perf , 性能诊断 , stap , systemtap , strace , dtrace , dwarf , profiler , perf_events , probe , dynamic probe , tracepoint 背景 数据库的性能优化是一个非常经典的话题,数据库的优化手段以及优化的角度也各不相同. 例如,可以从OS内核.网络.块设备.编译器.文件系统.SQL.数据库参数.业务逻辑.源码等各个方面去进行优化. 但是如果在优化			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgVd3Ab.html" rel="bookmark">为自己搭建一个鹊桥 -- Native Page与Web View之间的JSBridge实现方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:为自己搭建一个鹊桥 -- Native Page与Web View之间的JSBridge实现方式 说起JSBridge,大家最熟悉的应该就是微信的WeixinJSBridge,通过它各个公众页面可以调用后台方法和微信进行交互,为用户提供相关功能.我们就来说说UWP下怎么样实现我们自己的JSBridge. 在win10之前,如果需要实现JSBridge,我们大概有两种方法: 1. window.external.notify 做过webview的小伙伴肯定都熟悉,html页面可以通过wind			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5Nynqz.html" rel="bookmark">LeetCode 104 Maximum Depth of Binary Tree（二叉树的最大深度）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				翻译 给定一个二叉树,找出它的最大深度. 最大深度是指的从根节点一直到最远的叶节点中所有的节点数目. 原文 Given a binary tree, find its maximum depth. The maximum depth is the number of nodes along the longest path from the root node down to the farthest leaf node. 代码 /** * Definition for a binary tre			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGAV4vM.html" rel="bookmark">visual studio 2010- Visual Studio Profiling Control Driver 的作用是什么？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Visual Studio Profiling Control Driver 的作用是什么? 本人大一,IP课老师让下载这个软件,我们这学期讲的是C ,我用Win8.1 的系统,但是他却阻止 Visual Studio Profiling Control Driver的运行,不知道是否会对软件产生影响,先谢谢了!!!我下载的版本是VS2010 解决方案 建议使用2013,2010比较老了,和Win8.1兼容性不太好.但是如果你只是学校里面学点简单的C语言,显然这东西应该没关系的.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boKlJgb.html" rel="bookmark">设置-nutch TopN 50万 depth 10 获取到6万多数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 nutch TopN 50万 depth 10 获取到6万多数据 我用nutch1.9搜索阿里巴巴的网站,使用的是bin/crawl 脚本执行的,topN设置的50万,爬行深度设置的10,url过滤只允许阿里巴巴的网站,但是实际搜出来的结果却只有6万多,又人知道大概是什么原因吗困扰了好几天了.....求教 解决方案 网站发现你爬虫,ban了你的请求 解决方案二: 这个没很好办法,模拟浏览器,多换IP,降低频率.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOm4GRM.html" rel="bookmark">JSBridge深度剖析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 做过混合开发的人都知道Ionic和PhoneGap之类的框架,这些框架在web基础上包装一层Native,然后通过Bridge技术的js调用本地的库. 在讲JSBridge技术之前,我们来看一下传统的实现方式. Android端 Native调JS native调用js比较简单,只要遵循:&quot;javascript: 方法名('参数,需要转为字符串')&quot;的规则即可. 在4.4之前,调用的方式: // mWebView = new WebView(this); mWebView.loa			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlB0Lz.html" rel="bookmark" class="title">如何在Word中输入千分号和万分号？</a>
					<div>
						  Word中千分号怎么打? 单击插入→特殊符号,出现插入特殊符号对话框,选择单位符号标签,就可以找到千分号,双击即可. 此外,也可以在英文输入状态下,按下Alt+0137(小键盘),也可以输入. W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNB5mM.html" rel="bookmark" class="title">C&num;首席设计师Anders Hejlsberg专访&lpar;一&rpar;</a>
					<div>
						设计 C#首席设计师Anders Hejlsberg专访 作者:John Osborn 译者:荣 耀 [译序:精彩技术,不容错过!限于时间和能力,译文倘有讹误,当以英文原版为准.] 7月,O'Reil ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvgWVp.html" rel="bookmark" class="title">《Essential &period;Net》读书笔记 - Chapter 1</a>
					<div>
						笔记 Chapter 1: 1.         组件技术主要强调的是独立开发和部署程序之间的协定(contract,就是说好怎么做就要怎么做).COM是M$首次尝试将这些约定规范化.COM出现之前, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLO0kaM.html" rel="bookmark" class="title">运用WebSphere Studio V5&period;1&period;1开发JSF应用程序&colon; 第4部分</a>
					<div>
						这一系列文章展示了 WebSphere Studio V5.1.1 中的 Java Server Faces TechnologyPreview 的特征,本文是其中的第 4 部分 在文章系列的 第 3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4Zl8p.html" rel="bookmark" class="title">在Linux系统上使用Bugzilla跟踪bug</a>
					<div>
						对于负责提供支持的人而言,保持对问题.难题及其修订的跟踪,可能会是一项棘手的任务:不过,有一个完美的开源方案可以满足这一要求:Bugzilla.安装它之后,您就可以方便地跟踪 bug 了,并可在发现特 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKlLvp.html" rel="bookmark" class="title">PS合成复古风格的灿烂生如夏花签名</a>
					<div>
						  本教程主要使用Photoshop制作复古风格的真人成签教程,教程主要两个部分,一个是素材的叠加和后期颜色的调整 原图: 效果图: 教程: 教程结束,以上就是PS合成复古风格的灿烂生如夏花签名方法介 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7O8Vb.html" rel="bookmark" class="title">PS制作以生物为题材的logo设计</a>
					<div>
						  从我开始创作以生物为题材的logo到现在,已经有一年多的时间了.而以生物为题材的网站设计也终于轰然启动,今天我将用我设计的logo来和大家一起分享一下设计流程.以生物为题材的logo与其它logo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxW5a0b.html" rel="bookmark" class="title">常见的原始JS选择器使用方法总结</a>
					<div>
						 常见的原始JS选择器有getElementById,getElementsByName,getElementsByTagName,就使用上为大家总结下 常见的getElementById,getEl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd65e3b.html" rel="bookmark" class="title">用苹果iSync使手机与电脑Mac 同步的技巧</a>
					<div>
						  要让所有资讯永远保持最新状态,其实不必把工夫花在比较.对照.分类整理上.有了 iSync,您可以让苹果电脑与 iPod.Palm OS 装置.蓝牙手机.USB连接的手机上的&quot;通讯录&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaxgQM.html" rel="bookmark" class="title">小工具 - 批量删除Maven下载失败的文件夹</a>
					<div>
						用过Maven的应该都遇到过,当网速不好或者源有问题的时候,Maven的依赖包经常下载失败. 下载失败后在本地仓库对应的文件夹中有一个以.lastUpdated结尾的文件,如果不手动删除这个文件,就不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZyRxb.html" rel="bookmark" class="title">java中一直有非法字符</a>
					<div>
						问题描述 java中一直有非法字符 解决方案 java编译错误: 非法字符: 65279java 非法字符: 65279java屏蔽非法字符 解决方案二: 明显是字符编码的问题嘛...你可以去看一下字 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NqmNM.html" rel="bookmark" class="title">代码-学生管理系统C&num;窗体界面</a>
					<div>
						问题描述 学生管理系统C#窗体界面 我们现在需要用C#作一个管理系统,其中会很多&quot;botten&quot;来实现界面的跳转,求代码. 解决方案 Form2 form2=new Form; f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdExm2z.html" rel="bookmark" class="title">雷军：不喜欢被人叫做雷布斯</a>
					<div>
						雷军的野心,远比我最初想象得大. 而且,这野心,并不是空中楼阁. 中国本土已经可以支撑世界级的互联网企业,腾讯成为市值超过1000亿美元的帝国,微信在海外已有超过1亿用户,阿里巴巴放在全球电子商务的舞 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAL6vM.html" rel="bookmark" class="title">使命必达&colon; 深入剖析WCF的可靠会话&lbrack;编程篇&rsqb;（下）</a>
					<div>
						整个可靠会话的机制是完全在信道层实现的,而整个信道层的最终缔造者就是绑定,所以可靠会话编程是围绕着绑定进行的.&lt;上篇&gt;对实现可靠会话的绑定元素已经如何使用系统绑定实现可靠会话进行了介绍,下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYj83Bp.html" rel="bookmark" class="title">自定义View系列教程04--Draw源码分析及其实践</a>
					<div>
						探索Android软键盘的疑难杂症 深入探讨Android异步精髓Handler 详解Android主流框架不可或缺的基石 站在源码的肩膀上全解Scroller工作机制 Android多分辨率适配框架 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YeNVM.html" rel="bookmark" class="title">常见网络命令之Ping命令</a>
					<div>
						前言:计算机网络老师要求我们自己总结一下常见的网络命,然后上课可以上去讲一下这些命令使用,像我这么听话的好学生,肯定是照老师要求,认真的总结了一下,总结的过程中,我发现网上已经有的资源讲的都不是很详细 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQWE5p.html" rel="bookmark" class="title">【编程练习】八大排序算法</a>
					<div>
						  概述 排序有内部排序和外部排序,内部排序是数据记录在内存中进行排序,而外部排序是因排序的数据很大,一次不能容纳全部的排序记录,在排序过程中需要访问外存. 我们这里说说八大排序就是内部排序.     ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWRomz.html" rel="bookmark" class="title">java-Java中string和stringbuffer有什么区别？？？</a>
					<div>
						问题描述 Java中string和stringbuffer有什么区别??? Java中string和stringbuffer有什么区别???求各位前辈指点 解决方案 String,StringBuil ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKVj8b.html" rel="bookmark" class="title">请问大家有没有遇到这样的问题&quest;aspx页面的设计视图怎么不能用了？　一单击设计视图，这个页面就处于一种好像死机了的状态，必须反它关掉，再打开才行．！设计视图为什么不能用了？</a>
					<div>
						问题描述 如题?我安的是VisualWebDevelop2008速成版． 解决方案 解决方案二:你的页面设计的很复杂吗?偶尔会报错,但是刷新一下就好了,也极少遇到.解决方案三:楼主,应该升级电脑配置了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZmOAz.html" rel="bookmark" class="title">javascript showModalDialog&comma;open取得父窗口的方法&lowbar;javascript技巧</a>
					<div>
						通常使用window.open的方式开启新窗口的话 要取得父窗口的控件,可以用window.opener来取得父窗口 然而如果使用showModalDialog的话...却无效 如果有需要的话,需要修 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLvYZp.html" rel="bookmark" class="title">c语言-C语言中如何删除TXT文件中特定的结构体数组</a>
					<div>
						问题描述 C语言中如何删除TXT文件中特定的结构体数组 用 r 打开文本文件a, 用a打开文本文件b,(临时文件) for{ fprintf 将a文件的数据存入fp: 判断是不是符合要删除的数据: 如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RNWmz.html" rel="bookmark" class="title">Resin4&period;0&period;37&plus;Spring3&period;1&period;1&plus;Hessian4&period;0&period;7&plus;Linux&plus;&lbrace;ThreadLauncher2&lbrack;ThreadPool&lbrack;system&rsqb;&rsqb;-</a>
					<div>
						问题描述 1.系统在Windows下运行是正常的,接口的调用没有问题:2.现在要迁移到Linux环境,问题就来了,客户端一调用接口服务就会挂掉啊[15-01-0515:54:13.858]{Threa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4e3yYb.html" rel="bookmark" class="title">洪波：淘宝封百度爬虫赌什么</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 淘宝很果敢,真的把百度爬虫给封了.淘宝不封别的搜索引擎,单封百度,很明显,是两家互联网巨头之间的对赌. 百度进军电子商务,成不成先不说,这个动作让马云非 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JX7Nz.html" rel="bookmark" class="title">中国服装重组材料中29个问题需解释</a>
					<div>
						中国服装(行情,问诊)23日晚公告称,2013年9月18日,公司收到证监会&lt;行政许可项目审查一次反馈 意见通知书&gt;,要求公司对提交的&lt;重大资产置换及发行股份购买资产暨关联交易&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkm68M.html" rel="bookmark" class="title">NFV玩家在MWC上向移动运营商大力推广其产品</a>
					<div>
						2016年世界移动大会(MWC2016)这一周的焦点,以新手机.充电器.VR头戴式耳机和大展台展示为主,另外也有大量有关网络功能虚拟化(NFV)产品的发布. 思科也加了进来,并宣布了用思科UCS服务器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBnlJM.html" rel="bookmark" class="title">word2003没问题&comma;word07超出数值范围</a>
					<div>
						问题描述 word2003没问题,word07超出数值范围 SetWidth方法设置列宽的时候,word2003没问题,但是在07环境下报异常:超出数值范围 解决方案 看下是不是纸张设置的问题					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4exxPb.html" rel="bookmark" class="title">程序装入方式-存储器管理方面的问题</a>
					<div>
						问题描述 存储器管理方面的问题 为什么程序的绝对装入方式只能用在单道程序设计中??多道程序设计为什么不能用??					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKqR4M.html" rel="bookmark" class="title">使用wordpress的&dollar;wpdb类读mysql数据库做ajax时出现的问题该如何解决&lowbar;AJAX相关</a>
					<div>
						无聊做了个www.jiazhuangma.com,技术不过关写不好后台,就想直接读wordpress里的数据.做ajax读后台数据时在网上随便搜了一段代码使用wordpress $wpdb类读mysq ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqyKWp.html" rel="bookmark" class="title">java两种单例模式用法分析&lowbar;java</a>
					<div>
						本文实例讲述了java两种单例模式用法.分享给大家供大家参考,具体如下: 按照加载方式的不同,单例模式有两种实现: private:只能在同一个类中使用 static:该类是类方法,不能调用实例方法. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYyK9b.html" rel="bookmark" class="title">python-Python 获取13位时间戳</a>
					<div>
						问题描述 Python 获取13位时间戳 今天用Python 模拟抓取网站上的数据,发现js生成的时间都是13位的,我用Python 该怎么获取对应的13位时间戳 解决方案 import time t ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
